package main

import (
	"krakatoa.net/backend/modules/configs/kraSettingsConfig"
	"krakatoa.net/backend/modules/configs/serverConfig"
	"krakatoa.net/backend/modules/logger"
	"krakatoa.net/backend/modules/mongo"
	"krakatoa.net/backend/serverCommunication"
	"krakatoa.net/backend/servers/minecraft"
	"krakatoa.net/backend/servers/web"
)

func init() {
	serverConfig.LoadServerConfig()

	kraSettingsConfig.LoadKraSettingsConfig()
	logger.Init()
	mongo.InitDatabase()
}

func main() {
	web.RunServer()
	go web.Test()
	go serverCommunication.AckHandler()

	minecraft.RunServer()
}

/*
	"u"nsigned can hold only positive values
	signed can hold negative and positve values
*/

// TODO: longer url when player joined for streamer protection
